<?php
/**
 * Adore Themes Customizer
 *
 * @package Social News
 *
 * Breaking News Section
 */

$wp_customize->add_section(
	'social_news_breaking_news_section',
	array(
		'title' => esc_html__( 'Breaking News Section', 'social-news' ),
		'panel' => 'social_news_frontpage_panel',
	)
);

// Breaking News section enable settings.
$wp_customize->add_setting(
	'social_news_breaking_news_section_enable',
	array(
		'default'           => false,
		'sanitize_callback' => 'social_news_sanitize_checkbox',
	)
);

$wp_customize->add_control(
	new Social_News_Toggle_Checkbox_Custom_control(
		$wp_customize,
		'social_news_breaking_news_section_enable',
		array(
			'label'    => esc_html__( 'Enable Breaking News Section', 'social-news' ),
			'type'     => 'checkbox',
			'settings' => 'social_news_breaking_news_section_enable',
			'section'  => 'social_news_breaking_news_section',
		)
	)
);

// Breaking News title settings.
$wp_customize->add_setting(
	'social_news_breaking_news_title',
	array(
		'default'           => __( 'Breaking News', 'social-news' ),
		'sanitize_callback' => 'sanitize_text_field',
	)
);

$wp_customize->add_control(
	'social_news_breaking_news_title',
	array(
		'label'           => esc_html__( 'Title', 'social-news' ),
		'section'         => 'social_news_breaking_news_section',
		'active_callback' => 'social_news_if_breaking_news_enabled',
	)
);

// Abort if selective refresh is not available.
if ( isset( $wp_customize->selective_refresh ) ) {
	$wp_customize->selective_refresh->add_partial(
		'social_news_breaking_news_title',
		array(
			'selector'            => '.breaking-news-section h3.breaking-news-label',
			'settings'            => 'social_news_breaking_news_title',
			'container_inclusive' => false,
			'fallback_refresh'    => true,
			'render_callback'     => 'social_news_breaking_news_title_text_partial',
		)
	);
}

// Flash News Section - Speed Controller.
$wp_customize->add_setting(
	'social_news_breaking_news_speed_controller',
	array(
		'default'           => 200,
		'sanitize_callback' => 'social_news_sanitize_number_range',
	)
);

$wp_customize->add_control(
	'social_news_breaking_news_speed_controller',
	array(
		'label'           => esc_html__( 'Speed Controller', 'social-news' ),
		'description'     => esc_html__( 'Note: Default speed value is 200.', 'social-news' ),
		'section'         => 'social_news_breaking_news_section',
		'settings'        => 'social_news_breaking_news_speed_controller',
		'type'            => 'number',
		'input_attrs'     => array(
			'min' => 1,
		),
		'active_callback' => 'social_news_if_breaking_news_enabled',
	)
);

// breaking_news content type settings.
$wp_customize->add_setting(
	'social_news_breaking_news_content_type',
	array(
		'default'           => 'post',
		'sanitize_callback' => 'social_news_sanitize_select',
	)
);

$wp_customize->add_control(
	'social_news_breaking_news_content_type',
	array(
		'label'           => esc_html__( 'Content type:', 'social-news' ),
		'description'     => esc_html__( 'Choose where you want to render the content from.', 'social-news' ),
		'section'         => 'social_news_breaking_news_section',
		'type'            => 'select',
		'active_callback' => 'social_news_if_breaking_news_enabled',
		'choices'         => array(
			'post'     => esc_html__( 'Post', 'social-news' ),
			'category' => esc_html__( 'Category', 'social-news' ),
		),
	)
);

for ( $i = 1; $i <= 5; $i++ ) {
	// breaking_news post setting.
	$wp_customize->add_setting(
		'social_news_breaking_news_post_' . $i,
		array(
			'sanitize_callback' => 'social_news_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'social_news_breaking_news_post_' . $i,
		array(
			'label'           => sprintf( esc_html__( 'Post %d', 'social-news' ), $i ),
			'section'         => 'social_news_breaking_news_section',
			'type'            => 'select',
			'choices'         => social_news_get_post_choices(),
			'active_callback' => 'social_news_breaking_news_section_content_type_post_enabled',
		)
	);

}

// breaking_news category setting.
$wp_customize->add_setting(
	'social_news_breaking_news_category',
	array(
		'sanitize_callback' => 'social_news_sanitize_select',
	)
);

$wp_customize->add_control(
	'social_news_breaking_news_category',
	array(
		'label'           => esc_html__( 'Category', 'social-news' ),
		'section'         => 'social_news_breaking_news_section',
		'type'            => 'select',
		'choices'         => social_news_get_post_cat_choices(),
		'active_callback' => 'social_news_breaking_news_section_content_type_category_enabled',
	)
);

/*========================Active Callback==============================*/
function social_news_if_breaking_news_enabled( $control ) {
	return $control->manager->get_setting( 'social_news_breaking_news_section_enable' )->value();
}
function social_news_breaking_news_section_content_type_post_enabled( $control ) {
	$content_type = $control->manager->get_setting( 'social_news_breaking_news_content_type' )->value();
	return social_news_if_breaking_news_enabled( $control ) && ( 'post' === $content_type );
}
function social_news_breaking_news_section_content_type_category_enabled( $control ) {
	$content_type = $control->manager->get_setting( 'social_news_breaking_news_content_type' )->value();
	return social_news_if_breaking_news_enabled( $control ) && ( 'category' === $content_type );
}

/*========================Partial Refresh==============================*/
if ( ! function_exists( 'social_news_breaking_news_title_text_partial' ) ) :
	// Title.
	function social_news_breaking_news_title_text_partial() {
		return esc_html( get_theme_mod( 'social_news_breaking_news_title' ) );
	}
endif;
